VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSubfolders"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Sti til den gjeldene nkkel og type
Private KeyPath As String
Private KeyType As RegTypes
Private Values As Boolean
Private SubValue As String

' Alle nklene i form av en collection
Private cKeys As Collection

Friend Sub Initialize(sPath As String, bValues As Boolean, lngType As RegTypes, sSubValue As String)

    Dim hKey As Long, Cnt As Long, sName As String, Ret As Long

    ' Lag collection
    Set cKeys = New Collection
    
    ' Nkkelnavnet kan, som konsekvens av dette, ikke overstige 255 karakterer
    Ret = BUFFER_SIZE

    ' pne registernkkel
    If RegOpenKey(HKEY_CLASSES_ROOT, sPath, hKey) = 0 Then
        
        ' Alloker en buffer
        sName = Space(BUFFER_SIZE)
        
        'Enumer alle nkler
        Do
        
            ' Sjekk hva vi skal lete etter
            If bValues Then
            
                ' Let etter underverdier
                If RegEnumValue(hKey, Cnt, sName, Ret, 0, ByVal 0&, ByVal 0&, 0) = ERROR_NO_MORE_ITEMS Then
                    ' Vi er ferdige
                    Exit Do
                End If

            Else
        
                ' Let etter undernkler
                If RegEnumKeyEx(hKey, Cnt, sName, Ret, ByVal 0&, vbNullString, ByVal 0&, ByVal 0&) = ERROR_NO_MORE_ITEMS Then
                    ' Vi er ferdige
                    Exit Do
                End If
            
            End If
            
            ' Legg til nkkel/verdi
            cKeys.Add Left$(sName, Ret)
            
            ' Tilrettelegg variabler til neste enumerasjonssteg
            Cnt = Cnt + 1
            sName = Space(BUFFER_SIZE)
            Ret = BUFFER_SIZE
        Loop
        
        ' Lukk registernkkel
        RegCloseKey hKey
    End If

    ' Lagre sti samt andre variabler
    KeyPath = sPath
    KeyType = lngType
    Values = bValues
    SubValue = sSubValue

End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"

    ' Bruk enumeringsklasse fra Collection
    Set NewEnum = cKeys.[_NewEnum]

End Property

Public Sub Add(sName As String, Optional sValue As String)
    
    ' Legg til denne registernkkel/-verdi
    RegWrite HKEY_CLASSES_ROOT, KeyPath & IIf(Values, "", "\" & sName), IIf(Values, sName, vbNullString), ConvertString(vbNullString), KeyType

    ' Sett dernest verdivariabel
    Value(sName) = sValue

End Sub

Public Function Item(Index)

    ' Returner ett element
    Item = cKeys.Item(Index)

End Function

Public Function Count()

    ' Returner antall elementet
    Count = cKeys.Count

End Function

Public Function Remove(sName As String)

    If Values Then
        ' Slett registerverdi
        SHDeleteValue HKEY_CLASSES_ROOT, KeyPath, sName
    Else
        ' Slett registernkkel
        SHDeleteKey HKEY_CLASSES_ROOT, KeyPath & "\" & sName
    End If
    
    ' Oppdater liste
    Initialize KeyPath, Values, KeyType

End Function

' Only used in "Actions"
Public Property Get Value(ByVal sName As String) As String

    ' Fortsett dersom uthentelse er angitt
    If Len(SubValue) > 0 Then
        ' Returner verdi
        Value = RegRead(HKEY_CLASSES_ROOT, KeyPath & "\" & sName & "\" & SubValue, vbNullString)
    End If

End Property

Public Property Let Value(ByVal sName As String, ByVal vNewValue As String)

    ' Fortsett dersom uthentelse er angitt
    If Len(SubValue) > 0 Then
        ' Sett verdi
        RegWrite HKEY_CLASSES_ROOT, KeyPath & "\" & sName & "\" & SubValue & "\", vbNullString, ConvertString(vNewValue), REG_SZ
    End If

End Property
