Attribute VB_Name = "modRegistry"
Option Explicit

' Benyttet til manipulering og uthenting av data i registeret
Public Declare Function SHDeleteKey Lib "shlwapi.dll" Alias "SHDeleteKeyA" (ByVal hKey As Long, ByVal pszSubKey As String) As Long
Public Declare Function SHDeleteValue Lib "shlwapi.dll" Alias "SHDeleteValueA" (ByVal hKey As Long, pszSubKey As String, pszValue As String) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As Any) As Long
Public Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Public Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)

Enum RegTypes
    REG_BINARY = 3
    REG_DWORD = 4
    REG_EXPAND_SZ = 2
    REG_DWORD_LITTLE_ENDIAN = 4
    REG_DWORD_BIG_ENDIAN = 5
    REG_NONE = 0
    REG_MULTI_SZ = 7
    REG_LINK = 6
    REG_SZ = 1
End Enum

Public Const ERROR_NO_MORE_ITEMS = 259&
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const BUFFER_SIZE As Long = 255

Private Function RegQueryStringValue(ByVal hKey As Long, ByVal strValueName As String) As Variant
    
    Dim lResult As Long, lValueType As Long, strBuf As String, lDataBufSize As Long
    
    ' Hent informasjon om registernkkel
    lResult = RegQueryValueEx(hKey, strValueName, 0, lValueType, ByVal 0, lDataBufSize)
    
    ' Dersom den forrige operasjonen forlp problemfritt, kan vi begynne uthentelsen av data
    If lResult = 0 Then
        
        Select Case lValueType
        Case REG_SZ
            
            ' Alloker en buffer
            strBuf = String(lDataBufSize, Chr$(0))
            
            ' Hent innholdet av denne nkkelen
            lResult = RegQueryValueEx(hKey, strValueName, 0, 0, ByVal strBuf, lDataBufSize)
            
            If lResult = 0 Then
                ' Fjern undvendige nullkarakterer
                RegQueryStringValue = Left$(strBuf, InStr(1, strBuf, Chr$(0)) - 1)
            End If
        
        Case REG_BINARY
        
            Dim aData() As Byte
            
            ' Alloker buffer
            ReDim aData(1 To lDataBufSize)
            
            ' Hent innhold
            lResult = RegQueryValueEx(hKey, strValueName, 0, 0, aData(1), lDataBufSize)
            
            If lResult = 0 Then
                ' Returner byte-array
                RegQueryStringValue = aData
            End If
            
        End Select
        
    End If
    
End Function

Public Function RegRead(hKey As Long, strPath As String, strValue As String)
    
    Dim Ret As Long
    
    ' pne nkkel
    RegOpenKey hKey, strPath, Ret
    
    ' Avles nkkelverdi
    RegRead = RegQueryStringValue(Ret, strValue)
    
    ' Lukk nkkel
    RegCloseKey Ret
    
End Function

Public Function ConvertString(sText As String) As Byte()

    ' Returner den konverterte arrayen
    ConvertString = StrConv(sText & Chr(0), vbFromUnicode)

End Function

Public Sub RegWrite(hKey As Long, strPath As String, strValue As String, aData() As Byte, KeyType As RegTypes)
    
    Dim Ret As Long
    
    'Create a new key
    RegCreateKey hKey, strPath, Ret
    
    ' Lagre informasjonen til registernkkel
    RegSetValueEx Ret, strValue, 0, KeyType, aData(LBound(aData)), UBound(aData) - LBound(aData) + 1
    
    'close the key
    RegCloseKey Ret
    
End Sub
